`timescale 1ns / 1ps

module RegEventControl #(
    parameter DATA_WIDTH = 32
    )(
    input logic ck,
    input logic arst,
    input logic writeAck,
    input logic irqIn,
    input logic [DATA_WIDTH-1:0] ctrlReg,
    output logic [DATA_WIDTH-1:0] writeData,
    output logic writeReq
    );
     
    always_ff @(posedge ck or posedge arst) begin
      if(arst) 
        begin
          writeReq  <= 0;
          writeData <= 0;
        end
      else
        begin 
          if(irqIn)
            begin 
              writeData <= {{ctrlReg[DATA_WIDTH-1:1]},{1'b0}};
              writeReq <= 1;
            end
          else if(writeAck)
            begin
              writeReq <= 0;
            end
        end  
    end
    
endmodule
