// -------------------------------------------------------------
//
// Module: casfilt
// Generated by MATLAB(R) 9.1 and the Filter Design HDL Coder 3.1.
// Generated on: 2017-03-30 10:13:39
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// OptimizeForHDL: on
// TargetDirectory: HdlFilterCIC4
// Name: casfilt
// InputDataType: numerictype(1,16,15)
// TargetLanguage: Verilog
// TestBenchName: casfilt_tb
// TestBenchUserStimulus:  User data, length 100000
// ErrorMargin: 2

// -------------------------------------------------------------
// Stage 1               : Direct-Form FIR Polyphase Interpolator
// HDL Implementation    : Fully serial
// Folding Factor        : 33

//
// Stage 2               : Direct-Form FIR Polyphase Interpolator
// HDL Implementation    : Fully serial
// Folding Factor        : 6

//
// Stage 3               : Direct-Form FIR Polyphase Interpolator
// HDL Implementation    : Fully serial
// Folding Factor        : 6

//
// Stage 4               : Cascaded Integrator-Comb Interpolator
// HDL Implementation    : Fully parallel

//
// Stage 5               : Cascaded Integrator-Comb Interpolator
// HDL Implementation    : Fully parallel

//
// Stage 6               : Cascaded Integrator-Comb Interpolator
// HDL Implementation    : Fully parallel

//
// Stage 7               : Cascaded Integrator-Comb Interpolator
// HDL Implementation    : Fully parallel

//
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Filter (real)
// -------------------------------
// Filter Structure  : Cascade
// Number of Stages  : 7
// Stable            : Yes
// Linear Phase      : Yes (Type 2)
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module casfilt 
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [15:0] filter_in; //sfix16_En15
  output  signed [15:0] filter_out; //sfix16_En12
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: casfilt
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  // Signals
  wire signed [15:0] filter_in_stage1; // sfix16_En15
  wire signed [20:0] filter_out_stage1; // sfix21_En20
  wire clk_enable_stage1; // boolean
  wire ce_out_stage1; // boolean
  wire signed [20:0] filter_in_stage2; // sfix21_En20
  wire signed [19:0] filter_out_stage2; // sfix20_En19
  wire clk_enable_stage2; // boolean
  wire ce_out_stage2; // boolean
  wire signed [19:0] filter_in_stage3; // sfix20_En19
  wire signed [17:0] filter_out_stage3; // sfix18_En17
  wire clk_enable_stage3; // boolean
  wire ce_out_stage3; // boolean
  wire signed [17:0] filter_in_stage4; // sfix18_En17
  wire signed [18:0] filter_out_stage4; // sfix19_En16
  wire clk_enable_stage4; // boolean
  wire ce_out_stage4; // boolean
  wire signed [18:0] filter_in_stage5; // sfix19_En16
  wire signed [17:0] filter_out_stage5; // sfix18_En14
  wire clk_enable_stage5; // boolean
  wire ce_out_stage5; // boolean
  wire signed [17:0] filter_in_stage6; // sfix18_En14
  wire signed [16:0] filter_out_stage6; // sfix17_En13
  wire clk_enable_stage6; // boolean
  wire ce_out_stage6; // boolean
  wire signed [16:0] filter_in_stage7; // sfix17_En13
  wire signed [15:0] filter_out_stage7; // sfix16_En12
  wire clk_enable_stage7; // boolean
  wire ce_out_stage7; // boolean
  wire signed [20:0] filter_in_stage2_tmp; // sfix21_En20
  wire signed [19:0] filter_in_stage3_tmp; // sfix20_En19
  wire signed [17:0] filter_in_stage4_tmp; // sfix18_En17
  wire signed [18:0] filter_in_stage5_tmp; // sfix19_En16
  wire signed [17:0] filter_in_stage6_tmp; // sfix18_En14
  wire signed [16:0] filter_in_stage7_tmp; // sfix17_En13
  casfilt_stage1 u_casfilt_stage1
    (
    .clk(clk),
    .clk_enable_stage1(clk_enable_stage1),
    .reset(reset),
    .filter_in_stage1(filter_in_stage1),
    .filter_out_stage1(filter_out_stage1),
    .ce_out_stage1(ce_out_stage1)
    );

  casfilt_stage2 u_casfilt_stage2
    (
    .clk(clk),
    .clk_enable_stage2(clk_enable_stage2),
    .reset(reset),
    .filter_in_stage2(filter_in_stage2),
    .filter_out_stage2(filter_out_stage2),
    .ce_out_stage2(ce_out_stage2)
    );

  casfilt_stage3 u_casfilt_stage3
    (
    .clk(clk),
    .clk_enable_stage3(clk_enable_stage3),
    .reset(reset),
    .filter_in_stage3(filter_in_stage3),
    .filter_out_stage3(filter_out_stage3),
    .ce_out_stage3(ce_out_stage3)
    );

  casfilt_stage4 u_casfilt_stage4
    (
    .clk(clk),
    .clk_enable_stage4(clk_enable_stage4),
    .reset(reset),
    .filter_in_stage4(filter_in_stage4),
    .filter_out_stage4(filter_out_stage4),
    .ce_out_stage4(ce_out_stage4)
    );

  casfilt_stage5 u_casfilt_stage5
    (
    .clk(clk),
    .clk_enable_stage5(clk_enable_stage5),
    .reset(reset),
    .filter_in_stage5(filter_in_stage5),
    .filter_out_stage5(filter_out_stage5),
    .ce_out_stage5(ce_out_stage5)
    );

  casfilt_stage6 u_casfilt_stage6
    (
    .clk(clk),
    .clk_enable_stage6(clk_enable_stage6),
    .reset(reset),
    .filter_in_stage6(filter_in_stage6),
    .filter_out_stage6(filter_out_stage6),
    .ce_out_stage6(ce_out_stage6)
    );

  casfilt_stage7 u_casfilt_stage7
    (
    .clk(clk),
    .clk_enable_stage7(clk_enable_stage7),
    .reset(reset),
    .filter_in_stage7(filter_in_stage7),
    .filter_out_stage7(filter_out_stage7),
    .ce_out_stage7(ce_out_stage7)
    );


  // Block Statements
  assign filter_in_stage1 = filter_in;
  assign filter_in_stage2_tmp = filter_out_stage1;

  assign filter_in_stage2 = filter_in_stage2_tmp;
  assign filter_in_stage3_tmp = filter_out_stage2;

  assign filter_in_stage3 = filter_in_stage3_tmp;
  assign filter_in_stage4_tmp = filter_out_stage3;

  assign filter_in_stage4 = filter_in_stage4_tmp;
  assign filter_in_stage5_tmp = filter_out_stage4;

  assign filter_in_stage5 = filter_in_stage5_tmp;
  assign filter_in_stage6_tmp = filter_out_stage5;

  assign filter_in_stage6 = filter_in_stage6_tmp;
  assign filter_in_stage7_tmp = filter_out_stage6;

  assign filter_in_stage7 = filter_in_stage7_tmp;
  assign clk_enable_stage7 = clk_enable;
  assign clk_enable_stage6 = ce_out_stage7;
  assign clk_enable_stage5 = ce_out_stage6;
  assign clk_enable_stage4 = ce_out_stage5;
  assign clk_enable_stage3 = ce_out_stage4;
  assign clk_enable_stage2 = ce_out_stage3;
  assign clk_enable_stage1 = ce_out_stage2;
  assign ce_out = ce_out_stage1;
  // Assignment Statements
  assign filter_out = filter_out_stage7;
endmodule  // casfilt
