// -------------------------------------------------------------
//
// Module: filter
// Generated by MATLAB(R) 9.1 and the Filter Design HDL Coder 3.1.
// Generated on: 2017-01-31 09:54:32
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// OptimizeForHDL: on
// TargetDirectory: HdlFilter
// Name: casfilt
// InputDataType: numerictype(1,16,15)
// TargetLanguage: Verilog
// TestBenchName: casfilt_tb
// TestBenchUserStimulus:  User data, length 640
// ErrorMargin: 2

// Filter Specifications:
//
// Sample Rate          : N/A (normalized frequency)
// Response             : Halfband
// Specification        : TW,Ast
// Interpolation Factor : 2
// Multirate Type       : Interpolator
// Stopband Atten.      : 100 dB
// Type                 : Lowpass
// Transition Width     : 0.092971
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Implementation    : Fully Serial
// Folding Factor        : 33
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure      : Direct-Form FIR Polyphase Interpolator
// Interpolation Factor  : 2
// Polyphase Length      : 66
// Filter Length         : 131
// Stable                : Yes
// Linear Phase          : Yes (Type 1)
//
// Arithmetic            : fixed
// Numerator             : s22,20 -> [-2 2)
// -------------------------------------------------------------
// Multipliers           : 66



`timescale 1 ns / 1 ns

module casfilt_stage1
    (
    clk,
    clk_enable_stage1,
    reset,
    filter_in_stage1,
    filter_out_stage1,
    ce_out_stage1
    );

  input   clk; 
  input   clk_enable_stage1; 
  input   reset; 
  input   signed [15:0] filter_in_stage1; //sfix16_En15
  output  signed [20:0] filter_out_stage1; //sfix21_En20
  output  ce_out_stage1; 

  ////////////////////////////////////////////////////////////////
  //Module Architecture: casfilt_stage1
  ////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [21:0] coeff1 = 22'b0000000000000000010110; //sfix22_En20
  parameter signed [21:0] coeff2 = 22'b1111111111111111011010; //sfix22_En20
  parameter signed [21:0] coeff3 = 22'b0000000000000001000101; //sfix22_En20
  parameter signed [21:0] coeff4 = 22'b1111111111111110001101; //sfix22_En20
  parameter signed [21:0] coeff5 = 22'b0000000000000010110111; //sfix22_En20
  parameter signed [21:0] coeff6 = 22'b1111111111111011101010; //sfix22_En20
  parameter signed [21:0] coeff7 = 22'b0000000000000110011000; //sfix22_En20
  parameter signed [21:0] coeff8 = 22'b1111111111110110111011; //sfix22_En20
  parameter signed [21:0] coeff9 = 22'b0000000000001100101000; //sfix22_En20
  parameter signed [21:0] coeff10 = 22'b1111111111101110110100; //sfix22_En20
  parameter signed [21:0] coeff11 = 22'b0000000000010110111110; //sfix22_En20
  parameter signed [21:0] coeff12 = 22'b1111111111100001110010; //sfix22_En20
  parameter signed [21:0] coeff13 = 22'b0000000000100111001011; //sfix22_En20
  parameter signed [21:0] coeff14 = 22'b1111111111001101111000; //sfix22_En20
  parameter signed [21:0] coeff15 = 22'b0000000000111111011010; //sfix22_En20
  parameter signed [21:0] coeff16 = 22'b1111111110110000100111; //sfix22_En20
  parameter signed [21:0] coeff17 = 22'b0000000001100010100000; //sfix22_En20
  parameter signed [21:0] coeff18 = 22'b1111111110000110110010; //sfix22_En20
  parameter signed [21:0] coeff19 = 22'b0000000010010100001001; //sfix22_En20
  parameter signed [21:0] coeff20 = 22'b1111111101001100000011; //sfix22_En20
  parameter signed [21:0] coeff21 = 22'b0000000011011001100101; //sfix22_En20
  parameter signed [21:0] coeff22 = 22'b1111111011111001110111; //sfix22_En20
  parameter signed [21:0] coeff23 = 22'b0000000100111011001101; //sfix22_En20
  parameter signed [21:0] coeff24 = 22'b1111111010000101000011; //sfix22_En20
  parameter signed [21:0] coeff25 = 22'b0000000111001000100011; //sfix22_En20
  parameter signed [21:0] coeff26 = 22'b1111110111010111001001; //sfix22_En20
  parameter signed [21:0] coeff27 = 22'b0000001010100011101110; //sfix22_En20
  parameter signed [21:0] coeff28 = 22'b1111110010111001001111; //sfix22_En20
  parameter signed [21:0] coeff29 = 22'b0000010000101011110000; //sfix22_En20
  parameter signed [21:0] coeff30 = 22'b1111101001110101111001; //sfix22_En20
  parameter signed [21:0] coeff31 = 22'b0000011111110010001000; //sfix22_En20
  parameter signed [21:0] coeff32 = 22'b1111001010001010100111; //sfix22_En20
  parameter signed [21:0] coeff33 = 22'b0010100010110011111000; //sfix22_En20
  
  // Signals
  reg  accActive; // ufix1
  reg  [1:0] cur_count; // ufix2
  reg  [5:0] cur_count_2; // ufix6
  wire phase_1; // boolean
  wire counterActive; //boolean
  reg  signed [15:0] delay_pipeline [0:65] ; // sfix16_En15
  wire signed [15:0] preaddmux_a1; // sfix16_En15
  wire signed [15:0] preaddmux_b1; // sfix16_En15
  wire signed [16:0] tapsum_1; // sfix17_En15
  wire signed [15:0] add_signext; // sfix16_En15
  wire signed [15:0] add_signext_1; // sfix16_En15
  wire signed [16:0] tapsum_mcand_1; // sfix17_En15
  reg  signed [43:0] acc_out_1; // sfix44_En35
  wire signed [37:0] product_1; // sfix38_En35
  wire signed [21:0] product_1_mux; // sfix22_En20
  wire signed [38:0] mul_temp; // sfix39_En35
  wire signed [43:0] prod_typeconvert_1; // sfix44_En35
  wire signed [43:0] acc_sum_1; // sfix44_En35
  wire signed [43:0] acc_in_1; // sfix44_En35
  wire signed [43:0] add_signext_2; // sfix44_En35
  wire signed [43:0] add_signext_3; // sfix44_En35
  wire signed [44:0] add_temp; // sfix45_En35
  wire signed [20:0] output_typeconvert; // sfix21_En20
  

  // Block Statements
  always @ (posedge clk)
  begin: ce_output
    if (reset == 1'b1) begin
      cur_count <= 2'b00;
    end
    else begin
      if (clk_enable_stage1 == 1'b1) begin
        if (cur_count == 2'b01) begin
          cur_count <= 2'b00;
        end
        else begin
          cur_count <= cur_count + 1;
        end
      end
    end
  end // ce_output
  
  always @ (posedge clk)
  begin: Counter_process
    if (reset == 1'b1) begin
      cur_count_2 <= 6'b100000;
    end
    else begin
      if (counterActive == 1'b1) begin
        if (cur_count_2 == 6'b100000) begin
          cur_count_2 <= 6'b000000;
        end
        else begin
          cur_count_2 <= cur_count_2 + 1;
        end
      end
    end
  end // Counter_process
  
  always @ (posedge clk)
  begin: set_accActive
    if (reset == 1'b1) begin
      accActive <= 1'b0;
    end
    else begin
      accActive <= counterActive;
    end
  end // set_accActive  
  
  
  assign counterActive = (phase_1 == 1'b1 || cur_count_2 != 6'b100000)? 1 : 0;
  
  assign  phase_1 = (cur_count == 2'b01 && clk_enable_stage1 == 1'b1)? 1 : 0;

  //   ---------------- Delay Registers ----------------

  always @( posedge clk)
    begin: Delay_Pipeline_process
      if (reset == 1'b1) begin
        delay_pipeline[0] <= 0;
        delay_pipeline[1] <= 0;
        delay_pipeline[2] <= 0;
        delay_pipeline[3] <= 0;
        delay_pipeline[4] <= 0;
        delay_pipeline[5] <= 0;
        delay_pipeline[6] <= 0;
        delay_pipeline[7] <= 0;
        delay_pipeline[8] <= 0;
        delay_pipeline[9] <= 0;
        delay_pipeline[10] <= 0;
        delay_pipeline[11] <= 0;
        delay_pipeline[12] <= 0;
        delay_pipeline[13] <= 0;
        delay_pipeline[14] <= 0;
        delay_pipeline[15] <= 0;
        delay_pipeline[16] <= 0;
        delay_pipeline[17] <= 0;
        delay_pipeline[18] <= 0;
        delay_pipeline[19] <= 0;
        delay_pipeline[20] <= 0;
        delay_pipeline[21] <= 0;
        delay_pipeline[22] <= 0;
        delay_pipeline[23] <= 0;
        delay_pipeline[24] <= 0;
        delay_pipeline[25] <= 0;
        delay_pipeline[26] <= 0;
        delay_pipeline[27] <= 0;
        delay_pipeline[28] <= 0;
        delay_pipeline[29] <= 0;
        delay_pipeline[30] <= 0;
        delay_pipeline[31] <= 0;
        delay_pipeline[32] <= 0;
        delay_pipeline[33] <= 0;
        delay_pipeline[34] <= 0;
        delay_pipeline[35] <= 0;
        delay_pipeline[36] <= 0;
        delay_pipeline[37] <= 0;
        delay_pipeline[38] <= 0;
        delay_pipeline[39] <= 0;
        delay_pipeline[40] <= 0;
        delay_pipeline[41] <= 0;
        delay_pipeline[42] <= 0;
        delay_pipeline[43] <= 0;
        delay_pipeline[44] <= 0;
        delay_pipeline[45] <= 0;
        delay_pipeline[46] <= 0;
        delay_pipeline[47] <= 0;
        delay_pipeline[48] <= 0;
        delay_pipeline[49] <= 0;
        delay_pipeline[50] <= 0;
        delay_pipeline[51] <= 0;
        delay_pipeline[52] <= 0;
        delay_pipeline[53] <= 0;
        delay_pipeline[54] <= 0;
        delay_pipeline[55] <= 0;
        delay_pipeline[56] <= 0;
        delay_pipeline[57] <= 0;
        delay_pipeline[58] <= 0;
        delay_pipeline[59] <= 0;
        delay_pipeline[60] <= 0;
        delay_pipeline[61] <= 0;
        delay_pipeline[62] <= 0;
        delay_pipeline[63] <= 0;
        delay_pipeline[64] <= 0;
        delay_pipeline[65] <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          delay_pipeline[0] <= filter_in_stage1;
          delay_pipeline[1] <= delay_pipeline[0];
          delay_pipeline[2] <= delay_pipeline[1];
          delay_pipeline[3] <= delay_pipeline[2];
          delay_pipeline[4] <= delay_pipeline[3];
          delay_pipeline[5] <= delay_pipeline[4];
          delay_pipeline[6] <= delay_pipeline[5];
          delay_pipeline[7] <= delay_pipeline[6];
          delay_pipeline[8] <= delay_pipeline[7];
          delay_pipeline[9] <= delay_pipeline[8];
          delay_pipeline[10] <= delay_pipeline[9];
          delay_pipeline[11] <= delay_pipeline[10];
          delay_pipeline[12] <= delay_pipeline[11];
          delay_pipeline[13] <= delay_pipeline[12];
          delay_pipeline[14] <= delay_pipeline[13];
          delay_pipeline[15] <= delay_pipeline[14];
          delay_pipeline[16] <= delay_pipeline[15];
          delay_pipeline[17] <= delay_pipeline[16];
          delay_pipeline[18] <= delay_pipeline[17];
          delay_pipeline[19] <= delay_pipeline[18];
          delay_pipeline[20] <= delay_pipeline[19];
          delay_pipeline[21] <= delay_pipeline[20];
          delay_pipeline[22] <= delay_pipeline[21];
          delay_pipeline[23] <= delay_pipeline[22];
          delay_pipeline[24] <= delay_pipeline[23];
          delay_pipeline[25] <= delay_pipeline[24];
          delay_pipeline[26] <= delay_pipeline[25];
          delay_pipeline[27] <= delay_pipeline[26];
          delay_pipeline[28] <= delay_pipeline[27];
          delay_pipeline[29] <= delay_pipeline[28];
          delay_pipeline[30] <= delay_pipeline[29];
          delay_pipeline[31] <= delay_pipeline[30];
          delay_pipeline[32] <= delay_pipeline[31];
          delay_pipeline[33] <= delay_pipeline[32];
          delay_pipeline[34] <= delay_pipeline[33];
          delay_pipeline[35] <= delay_pipeline[34];
          delay_pipeline[36] <= delay_pipeline[35];
          delay_pipeline[37] <= delay_pipeline[36];
          delay_pipeline[38] <= delay_pipeline[37];
          delay_pipeline[39] <= delay_pipeline[38];
          delay_pipeline[40] <= delay_pipeline[39];
          delay_pipeline[41] <= delay_pipeline[40];
          delay_pipeline[42] <= delay_pipeline[41];
          delay_pipeline[43] <= delay_pipeline[42];
          delay_pipeline[44] <= delay_pipeline[43];
          delay_pipeline[45] <= delay_pipeline[44];
          delay_pipeline[46] <= delay_pipeline[45];
          delay_pipeline[47] <= delay_pipeline[46];
          delay_pipeline[48] <= delay_pipeline[47];
          delay_pipeline[49] <= delay_pipeline[48];
          delay_pipeline[50] <= delay_pipeline[49];
          delay_pipeline[51] <= delay_pipeline[50];
          delay_pipeline[52] <= delay_pipeline[51];
          delay_pipeline[53] <= delay_pipeline[52];
          delay_pipeline[54] <= delay_pipeline[53];
          delay_pipeline[55] <= delay_pipeline[54];
          delay_pipeline[56] <= delay_pipeline[55];
          delay_pipeline[57] <= delay_pipeline[56];
          delay_pipeline[58] <= delay_pipeline[57];
          delay_pipeline[59] <= delay_pipeline[58];
          delay_pipeline[60] <= delay_pipeline[59];
          delay_pipeline[61] <= delay_pipeline[60];
          delay_pipeline[62] <= delay_pipeline[61];
          delay_pipeline[63] <= delay_pipeline[62];
          delay_pipeline[64] <= delay_pipeline[63];
          delay_pipeline[65] <= delay_pipeline[64];
        end
      end
    end // Delay_Pipeline_process

  assign preaddmux_a1 = (cur_count_2 == 6'b000000) ? delay_pipeline[0] :
                        (cur_count_2 == 6'b000001) ? delay_pipeline[1] :
                        (cur_count_2 == 6'b000010) ? delay_pipeline[2] :
                        (cur_count_2 == 6'b000011) ? delay_pipeline[3] :
                        (cur_count_2 == 6'b000100) ? delay_pipeline[4] :
                        (cur_count_2 == 6'b000101) ? delay_pipeline[5] :
                        (cur_count_2 == 6'b000110) ? delay_pipeline[6] :
                        (cur_count_2 == 6'b000111) ? delay_pipeline[7] :
                        (cur_count_2 == 6'b001000) ? delay_pipeline[8] :
                        (cur_count_2 == 6'b001001) ? delay_pipeline[9] :
                        (cur_count_2 == 6'b001010) ? delay_pipeline[10] :
                        (cur_count_2 == 6'b001011) ? delay_pipeline[11] :
                        (cur_count_2 == 6'b001100) ? delay_pipeline[12] :
                        (cur_count_2 == 6'b001101) ? delay_pipeline[13] :
                        (cur_count_2 == 6'b001110) ? delay_pipeline[14] :
                        (cur_count_2 == 6'b001111) ? delay_pipeline[15] :
                        (cur_count_2 == 6'b010000) ? delay_pipeline[16] :
                        (cur_count_2 == 6'b010001) ? delay_pipeline[17] :
                        (cur_count_2 == 6'b010010) ? delay_pipeline[18] :
                        (cur_count_2 == 6'b010011) ? delay_pipeline[19] :
                        (cur_count_2 == 6'b010100) ? delay_pipeline[20] :
                        (cur_count_2 == 6'b010101) ? delay_pipeline[21] :
                        (cur_count_2 == 6'b010110) ? delay_pipeline[22] :
                        (cur_count_2 == 6'b010111) ? delay_pipeline[23] :
                        (cur_count_2 == 6'b011000) ? delay_pipeline[24] :
                        (cur_count_2 == 6'b011001) ? delay_pipeline[25] :
                        (cur_count_2 == 6'b011010) ? delay_pipeline[26] :
                        (cur_count_2 == 6'b011011) ? delay_pipeline[27] :
                        (cur_count_2 == 6'b011100) ? delay_pipeline[28] :
                        (cur_count_2 == 6'b011101) ? delay_pipeline[29] :
                        (cur_count_2 == 6'b011110) ? delay_pipeline[30] :
                        (cur_count_2 == 6'b011111) ? delay_pipeline[31] :
                        delay_pipeline[32];
  assign preaddmux_b1 = (cur_count_2 == 6'b000000) ? delay_pipeline[65] :
                        (cur_count_2 == 6'b000001) ? delay_pipeline[64] :
                        (cur_count_2 == 6'b000010) ? delay_pipeline[63] :
                        (cur_count_2 == 6'b000011) ? delay_pipeline[62] :
                        (cur_count_2 == 6'b000100) ? delay_pipeline[61] :
                        (cur_count_2 == 6'b000101) ? delay_pipeline[60] :
                        (cur_count_2 == 6'b000110) ? delay_pipeline[59] :
                        (cur_count_2 == 6'b000111) ? delay_pipeline[58] :
                        (cur_count_2 == 6'b001000) ? delay_pipeline[57] :
                        (cur_count_2 == 6'b001001) ? delay_pipeline[56] :
                        (cur_count_2 == 6'b001010) ? delay_pipeline[55] :
                        (cur_count_2 == 6'b001011) ? delay_pipeline[54] :
                        (cur_count_2 == 6'b001100) ? delay_pipeline[53] :
                        (cur_count_2 == 6'b001101) ? delay_pipeline[52] :
                        (cur_count_2 == 6'b001110) ? delay_pipeline[51] :
                        (cur_count_2 == 6'b001111) ? delay_pipeline[50] :
                        (cur_count_2 == 6'b010000) ? delay_pipeline[49] :
                        (cur_count_2 == 6'b010001) ? delay_pipeline[48] :
                        (cur_count_2 == 6'b010010) ? delay_pipeline[47] :
                        (cur_count_2 == 6'b010011) ? delay_pipeline[46] :
                        (cur_count_2 == 6'b010100) ? delay_pipeline[45] :
                        (cur_count_2 == 6'b010101) ? delay_pipeline[44] :
                        (cur_count_2 == 6'b010110) ? delay_pipeline[43] :
                        (cur_count_2 == 6'b010111) ? delay_pipeline[42] :
                        (cur_count_2 == 6'b011000) ? delay_pipeline[41] :
                        (cur_count_2 == 6'b011001) ? delay_pipeline[40] :
                        (cur_count_2 == 6'b011010) ? delay_pipeline[39] :
                        (cur_count_2 == 6'b011011) ? delay_pipeline[38] :
                        (cur_count_2 == 6'b011100) ? delay_pipeline[37] :
                        (cur_count_2 == 6'b011101) ? delay_pipeline[36] :
                        (cur_count_2 == 6'b011110) ? delay_pipeline[35] :
                        (cur_count_2 == 6'b011111) ? delay_pipeline[34] :
                        delay_pipeline[33];
  assign add_signext = preaddmux_a1;
  assign add_signext_1 = preaddmux_b1;
  assign tapsum_1 = add_signext + add_signext_1;

  assign tapsum_mcand_1 = tapsum_1;
 
  //   ------------------ Serial partition # 1 ------------------

  assign product_1_mux = (cur_count_2 == 6'b000000) ? coeff1 :
                         (cur_count_2 == 6'b000001) ? coeff2 :
                         (cur_count_2 == 6'b000010) ? coeff3 :
                         (cur_count_2 == 6'b000011) ? coeff4 :
                         (cur_count_2 == 6'b000100) ? coeff5 :
                         (cur_count_2 == 6'b000101) ? coeff6 :
                         (cur_count_2 == 6'b000110) ? coeff7 :
                         (cur_count_2 == 6'b000111) ? coeff8 :
                         (cur_count_2 == 6'b001000) ? coeff9 :
                         (cur_count_2 == 6'b001001) ? coeff10 :
                         (cur_count_2 == 6'b001010) ? coeff11 :
                         (cur_count_2 == 6'b001011) ? coeff12 :
                         (cur_count_2 == 6'b001100) ? coeff13 :
                         (cur_count_2 == 6'b001101) ? coeff14 :
                         (cur_count_2 == 6'b001110) ? coeff15 :
                         (cur_count_2 == 6'b001111) ? coeff16 :
                         (cur_count_2 == 6'b010000) ? coeff17 :
                         (cur_count_2 == 6'b010001) ? coeff18 :
                         (cur_count_2 == 6'b010010) ? coeff19 :
                         (cur_count_2 == 6'b010011) ? coeff20 :
                         (cur_count_2 == 6'b010100) ? coeff21 :
                         (cur_count_2 == 6'b010101) ? coeff22 :
                         (cur_count_2 == 6'b010110) ? coeff23 :
                         (cur_count_2 == 6'b010111) ? coeff24 :
                         (cur_count_2 == 6'b011000) ? coeff25 :
                         (cur_count_2 == 6'b011001) ? coeff26 :
                         (cur_count_2 == 6'b011010) ? coeff27 :
                         (cur_count_2 == 6'b011011) ? coeff28 :
                         (cur_count_2 == 6'b011100) ? coeff29 :
                         (cur_count_2 == 6'b011101) ? coeff30 :
                         (cur_count_2 == 6'b011110) ? coeff31 :
                         (cur_count_2 == 6'b011111) ? coeff32 :
                         coeff33;
  assign mul_temp = tapsum_mcand_1 * product_1_mux;
  assign product_1 = (mul_temp[38] == 1'b0 & mul_temp[37] != 1'b0) ? 38'b01111111111111111111111111111111111111 : 
                     (mul_temp[38] == 1'b1 && mul_temp[37] != 1'b1) ? 38'b10000000000000000000000000000000000000 : mul_temp[37:0];

  assign prod_typeconvert_1 = $signed({{6{product_1[37]}}, product_1});

  assign add_signext_2 = prod_typeconvert_1;
  assign add_signext_3 = acc_out_1;
  assign add_temp = add_signext_2 + add_signext_3; 
  assign acc_sum_1 = (add_temp[44] == 1'b0 & add_temp[43] != 1'b0) ? 44'b01111111111111111111111111111111111111111111 : 
                     (add_temp[44] == 1'b1 && add_temp[43] != 1'b1) ? 44'b10000000000000000000000000000000000000000000 : add_temp[43:0];
  
  assign acc_in_1 = (cur_count_2 == 6'b000000) ? prod_typeconvert_1 :
    acc_sum_1;

  always @ (posedge clk)
  begin: Acc_reg_1_process
    if (reset == 1'b1) begin
      acc_out_1 <= 0;
    end
    else begin
      if(accActive == 1'b1) begin
        acc_out_1 <= acc_in_1;
      end
    end
  end // Acc_reg_1_process  
  

  assign output_typeconvert = (cur_count == 2'b00) ? acc_out_1[35:15] :
                              $signed({delay_pipeline[32],{5{1'b0}}});

  // Assignment Statements
  assign ce_out_stage1 = phase_1;
  assign filter_out_stage1 = output_typeconvert;
endmodule  // casfilt_stage1
