// -------------------------------------------------------------
//
// Module: filter
// Generated by MATLAB(R) 9.1 and the Filter Design HDL Coder 3.1.
// Generated on: 2017-03-21 14:09:55
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// OptimizeForHDL: on
// TargetDirectory: HdlFilterCIC4
// Name: casfilt
// InputDataType: numerictype(1,16,15)
// TargetLanguage: Verilog
// TestBenchName: casfilt_tb
// TestBenchUserStimulus:  User data, length 640
// ErrorMargin: 2

// Filter Specifications:
//
// Sample Rate          : N/A (normalized frequency)
// Response             : Halfband
// Specification        : TW,Ast
// Interpolation Factor : 2
// Multirate Type       : Interpolator
// Stopband Atten.      : 100 dB
// Type                 : Lowpass
// Transition Width     : 0.5
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Implementation    : Fully Serial
// Folding Factor        : 6
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure      : Direct-Form FIR Polyphase Interpolator
// Interpolation Factor  : 2
// Polyphase Length      : 12
// Filter Length         : 23
// Stable                : Yes
// Linear Phase          : Yes (Type 1)
//
// Arithmetic            : fixed
// Numerator             : s20,18 -> [-2 2)
// -------------------------------------------------------------
// Multipliers           : 78



`timescale 1 ns / 1 ns

module casfilt_stage2
               (
                clk,
                clk_enable_stage2,
                reset,
                filter_in_stage2,
                filter_out_stage2,
                ce_out_stage2
                );

  input   clk; 
  input   clk_enable_stage2; 
  input   reset; 
  input   signed [20:0] filter_in_stage2; //sfix21_En20
  output  signed [19:0] filter_out_stage2; //sfix20_En19
  output  ce_out_stage2; 

////////////////////////////////////////////////////////////////
//Module Architecture: casfilt_stage2
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [19:0] coeff1 = 20'b11111111111101001010; //sfix20_En18
  parameter signed [19:0] coeff2 = 20'b00000000010100100110; //sfix20_En18
  parameter signed [19:0] coeff3 = 20'b11111110101100110010; //sfix20_En18
  parameter signed [19:0] coeff4 = 20'b00000011111010010010; //sfix20_En18
  parameter signed [19:0] coeff5 = 20'b11110101100000011010; //sfix20_En18
  parameter signed [19:0] coeff6 = 20'b00100111100110110001; //sfix20_En18
  
  // Signals
  reg  accActive; // ufix1
  reg  [1:0] cur_count; // ufix2
  reg  [2:0] cur_count_2; // ufix3
  wire phase_1; // boolean
  wire counterActive; //boolean
  reg  signed [20:0] delay_pipeline [0:11] ; // sfix21_En20
  wire signed [20:0] preaddmux_a1; // sfix21_En20
  wire signed [20:0] preaddmux_b1; // sfix21_En20
  wire signed [21:0] tapsum_1; // sfix22_En20
  wire signed [20:0] add_signext; // sfix21_En20
  wire signed [20:0] add_signext_1; // sfix21_En20
  wire signed [21:0] tapsum_mcand_1; // sfix22_En20
  reg  signed [43:0] acc_out_1; // sfix44_En38
  wire signed [40:0] product_1; // sfix41_En38
  wire signed [19:0] product_1_mux; // sfix20_En18
  wire signed [41:0] mul_temp; // sfix42_En38
  wire signed [43:0] prod_typeconvert_1; // sfix44_En38
  wire signed [43:0] acc_sum_1; // sfix44_En38
  wire signed [43:0] acc_in_1; // sfix44_En38
  wire signed [43:0] add_signext_2; // sfix44_En38
  wire signed [43:0] add_signext_3; // sfix44_En38
  wire signed [44:0] add_temp; // sfix45_En38
  wire signed [19:0] output_typeconvert; // sfix20_En19
  
  // Block Statements
  always @ (posedge clk)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 2'b00;
      end
      else begin
        if (clk_enable_stage2 == 1'b1) begin
          if (cur_count == 2'b01) begin
            cur_count <= 2'b00;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  always @ (posedge clk)
    begin: Counter_process
      if (reset == 1'b1) begin
        cur_count_2 <= 3'b101;
      end
      else begin
        if (counterActive == 1'b1) begin
          if (cur_count_2 == 3'b101) begin
            cur_count_2 <= 3'b000;
          end
          else begin
            cur_count_2 <= cur_count_2 + 1;
          end
        end
      end
    end // Counter_process
    
  always @ (posedge clk)
    begin: set_accActive
      if (reset == 1'b1) begin
        accActive <= 1'b0;
      end
      else begin
        accActive <= counterActive;
      end
    end // set_accActive   
  
  assign counterActive = (phase_1 == 1'b1 || cur_count_2 != 3'b101)? 1 : 0;  
    
  assign  phase_1 = (cur_count == 2'b01 && clk_enable_stage2 == 1'b1)? 1 : 0;

  //   ---------------- Delay Registers ----------------

  always @( posedge clk )
    begin: Delay_Pipeline_process
      if (reset == 1'b1) begin
        delay_pipeline[0] <= 0;
        delay_pipeline[1] <= 0;
        delay_pipeline[2] <= 0;
        delay_pipeline[3] <= 0;
        delay_pipeline[4] <= 0;
        delay_pipeline[5] <= 0;
        delay_pipeline[6] <= 0;
        delay_pipeline[7] <= 0;
        delay_pipeline[8] <= 0;
        delay_pipeline[9] <= 0;
        delay_pipeline[10] <= 0;
        delay_pipeline[11] <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          delay_pipeline[0] <= filter_in_stage2;
          delay_pipeline[1] <= delay_pipeline[0];
          delay_pipeline[2] <= delay_pipeline[1];
          delay_pipeline[3] <= delay_pipeline[2];
          delay_pipeline[4] <= delay_pipeline[3];
          delay_pipeline[5] <= delay_pipeline[4];
          delay_pipeline[6] <= delay_pipeline[5];
          delay_pipeline[7] <= delay_pipeline[6];
          delay_pipeline[8] <= delay_pipeline[7];
          delay_pipeline[9] <= delay_pipeline[8];
          delay_pipeline[10] <= delay_pipeline[9];
          delay_pipeline[11] <= delay_pipeline[10];
        end
      end
    end // Delay_Pipeline_process


  assign preaddmux_a1 = (cur_count_2 == 3'b000) ? delay_pipeline[0] :
                        (cur_count_2 == 3'b001) ? delay_pipeline[1] :
                        (cur_count_2 == 3'b010) ? delay_pipeline[2] :
                        (cur_count_2 == 3'b011) ? delay_pipeline[3] :
                        (cur_count_2 == 3'b100) ? delay_pipeline[4] :
                        delay_pipeline[5];
  assign preaddmux_b1 = (cur_count_2 == 3'b000) ? delay_pipeline[11] :
                        (cur_count_2 == 3'b001) ? delay_pipeline[10] :
                        (cur_count_2 == 3'b010) ? delay_pipeline[9] :
                        (cur_count_2 == 3'b011) ? delay_pipeline[8] :
                        (cur_count_2 == 3'b100) ? delay_pipeline[7] :
                        delay_pipeline[6];
  assign add_signext = preaddmux_a1;
  assign add_signext_1 = preaddmux_b1;
  assign tapsum_1 = add_signext + add_signext_1;

  assign tapsum_mcand_1 = tapsum_1;

  //   ------------------ Serial partition # 1 ------------------

  assign product_1_mux = (cur_count_2 == 3'b000) ? coeff1 :
                         (cur_count_2 == 3'b001) ? coeff2 :
                         (cur_count_2 == 3'b010) ? coeff3 :
                         (cur_count_2 == 3'b011) ? coeff4 :
                         (cur_count_2 == 3'b100) ? coeff5 :
                         coeff6;
  assign mul_temp = tapsum_mcand_1 * product_1_mux;
  assign product_1 = (mul_temp[41] == 1'b0 & mul_temp[40] != 1'b0) ? 41'b01111111111111111111111111111111111111111 : 
                     (mul_temp[41] == 1'b1 && mul_temp[40] != 1'b1) ? 41'b10000000000000000000000000000000000000000 : mul_temp[40:0];

  assign prod_typeconvert_1 = $signed({{3{product_1[40]}}, product_1});

  assign add_signext_2 = prod_typeconvert_1;
  assign add_signext_3 = acc_out_1;
  assign add_temp = add_signext_2 + add_signext_3;
  assign acc_sum_1 = (add_temp[44] == 1'b0 & add_temp[43] != 1'b0) ? 44'b01111111111111111111111111111111111111111111 : 
                     (add_temp[44] == 1'b1 && add_temp[43] != 1'b1) ? 44'b10000000000000000000000000000000000000000000 : add_temp[43:0];

  assign acc_in_1 = (cur_count_2 == 3'b000) ? prod_typeconvert_1 :
                     acc_sum_1;

  always @ (posedge clk)
  begin: Acc_reg_1_process
    if (reset == 1'b1) begin
      acc_out_1 <= 0;
    end
    else begin
      if (accActive == 1'b1) begin
        acc_out_1 <= acc_in_1;
      end
    end
  end // Acc_reg_1_process
  
  assign output_typeconvert = (cur_count == 2'b00) ? acc_out_1[38:19] : 
                              delay_pipeline[5][20:1];
  
  // Assignment Statements
  assign ce_out_stage2 = phase_1;
  assign filter_out_stage2 = output_typeconvert;
endmodule  // casfilt_stage2
