// -------------------------------------------------------------
//
// Module: filter
// Generated by MATLAB(R) 9.1 and the Filter Design HDL Coder 3.1.
// Generated on: 2017-03-21 14:09:56
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// OptimizeForHDL: on
// TargetDirectory: HdlFilterCIC4
// Name: casfilt
// InputDataType: numerictype(1,16,15)
// TargetLanguage: Verilog
// TestBenchName: casfilt_tb
// TestBenchUserStimulus:  User data, length 640
// ErrorMargin: 2

// Filter Specifications:
//
// Sample Rate          : N/A (normalized frequency)
// Response             : Inverse-sinc Lowpass
// Specification        : Fp,Fst,Ap,Ast
// Interpolation Factor : 2
// Multirate Type       : Interpolator
// Stopband Atten.      : 70 dB
// Passband Ripple      : 0.0001 dB
// Stopband Edge        : 0.875
// Passband Edge        : 0.125
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Implementation    : Fully Serial
// Folding Factor        : 6
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure      : Direct-Form FIR Polyphase Interpolator
// Interpolation Factor  : 2
// Polyphase Length      : 6
// Filter Length         : 12
// Stable                : Yes
// Linear Phase          : Yes (Type 2)
//
// Arithmetic            : fixed
// Numerator             : s16,14 -> [-2 2)
// -------------------------------------------------------------
// Multipliers           : 84



`timescale 1 ns / 1 ns

module casfilt_stage3
               (
                clk,
                clk_enable_stage3,
                reset,
                filter_in_stage3,
                filter_out_stage3,
                ce_out_stage3
                );

  input   clk; 
  input   clk_enable_stage3; 
  input   reset; 
  input   signed [19:0] filter_in_stage3; //sfix20_En19
  output  signed [17:0] filter_out_stage3; //sfix18_En17
  output  ce_out_stage3; 

////////////////////////////////////////////////////////////////
//Module Architecture: casfilt_stage3
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [15:0] coeff1 = 16'b1111111110000000; //sfix16_En14
  parameter signed [15:0] coeff2 = 16'b0000000001100011; //sfix16_En14
  parameter signed [15:0] coeff3 = 16'b0000011111000101; //sfix16_En14
  parameter signed [15:0] coeff4 = 16'b0100001101100010; //sfix16_En14
  parameter signed [15:0] coeff5 = 16'b1111001011000010; //sfix16_En14
  parameter signed [15:0] coeff6 = 16'b0000001000110101; //sfix16_En14

  // Signals
  reg  accActive; // ufix1
  reg  [1:0] cur_count; // ufix2
  reg  [2:0] cur_count_2; // ufix3
  wire phase_1; // boolean
  wire counterActive; //boolean
  reg  signed [19:0] delay_pipeline [0:5] ; // sfix20_En19
  wire signed [19:0] inputmux_1; // sfix20_En19
  reg  signed [38:0] acc_out_1; // sfix39_En33
  reg  signed [38:0] acc_final; // sfix39_En33
  wire signed [35:0] product_1; // sfix36_En33
  wire signed [15:0] product_1_mux; // sfix16_En14
  wire signed [38:0] prod_typeconvert_1; // sfix39_En33
  wire signed [38:0] acc_sum_1; // sfix39_En33
  wire signed [38:0] acc_in_1; // sfix39_En33
  wire signed [38:0] add_signext; // sfix39_En33
  wire signed [38:0] add_signext_1; // sfix39_En33
  wire signed [39:0] add_temp; // sfix40_En33
  wire signed [17:0] output_typeconvert; // sfix18_En17

  // Block Statements
  always @ (posedge clk)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 2'b00;
      end
      else begin
        if (clk_enable_stage3 == 1'b1) begin
          if (cur_count == 2'b01) begin
            cur_count <= 2'b00;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output
    
  always @ (posedge clk)
    begin: Counter_process
      if (reset == 1'b1) begin
        cur_count_2 <= 3'b101;
      end
      else begin
        if (counterActive == 1'b1) begin
          if (cur_count_2 == 3'b101) begin
            cur_count_2 <= 3'b000;
          end
          else begin
            cur_count_2 <= cur_count_2 + 1;
          end
        end
      end
    end // Counter_process
    
  always @ (posedge clk)
    begin: set_accActive
      if (reset == 1'b1) begin
        accActive <= 1'b0;
      end
      else begin
        accActive <= counterActive;
      end
    end // set_accActive   
  
  assign counterActive = (clk_enable_stage3 == 1'b1 || cur_count_2 != 3'b101)? 1 : 0; 
  
  assign  phase_1 = (cur_count == 2'b01 && clk_enable_stage3 == 1'b1)? 1 : 0;

  //   ---------------- Delay Registers ----------------

  always @( posedge clk)
    begin: Delay_Pipeline_process
      if (reset == 1'b1) begin
        delay_pipeline[0] <= 0;
        delay_pipeline[1] <= 0;
        delay_pipeline[2] <= 0;
        delay_pipeline[3] <= 0;
        delay_pipeline[4] <= 0;
        delay_pipeline[5] <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          delay_pipeline[0] <= filter_in_stage3;
          delay_pipeline[1] <= delay_pipeline[0];
          delay_pipeline[2] <= delay_pipeline[1];
          delay_pipeline[3] <= delay_pipeline[2];
          delay_pipeline[4] <= delay_pipeline[3];
          delay_pipeline[5] <= delay_pipeline[4];
        end
      end
    end // Delay_Pipeline_process

  assign inputmux_1 = (cur_count_2 == 3'b000) ? delay_pipeline[0] :
                      (cur_count_2 == 3'b001) ? delay_pipeline[1] :
                      (cur_count_2 == 3'b010) ? delay_pipeline[2] :
                      (cur_count_2 == 3'b011) ? delay_pipeline[3] :
                      (cur_count_2 == 3'b100) ? delay_pipeline[4] :
                      delay_pipeline[5];

  //   ------------------ Serial partition # 1 ------------------

  assign product_1_mux = (cur_count == 2'b00) ? (
                         (cur_count_2 == 3'b000) ? coeff1 :
                         (cur_count_2 == 3'b001) ? coeff2 :
                         (cur_count_2 == 3'b010) ? coeff3 :
                         (cur_count_2 == 3'b011) ? coeff4 :
                         (cur_count_2 == 3'b100) ? coeff5 :
                         coeff6) : (
                         (cur_count_2 == 3'b000) ? coeff6 :
                         (cur_count_2 == 3'b001) ? coeff5 :
                         (cur_count_2 == 3'b010) ? coeff4 :
                         (cur_count_2 == 3'b011) ? coeff3 :
                         (cur_count_2 == 3'b100) ? coeff2 :
                         coeff1);
  assign product_1 = inputmux_1 * product_1_mux;

  assign prod_typeconvert_1 = $signed({{3{product_1[35]}}, product_1});

  assign add_signext = prod_typeconvert_1;
  assign add_signext_1 = acc_out_1;
  assign add_temp = add_signext + add_signext_1;
  assign acc_sum_1 = (add_temp[39] == 1'b0 & add_temp[38] != 1'b0) ? 39'b011111111111111111111111111111111111111 : 
                     (add_temp[39] == 1'b1 && add_temp[38] != 1'b1) ? 39'b100000000000000000000000000000000000000 : add_temp[38:0];

  assign acc_in_1 = (cur_count_2 == 3'b000) ? prod_typeconvert_1 :
                     acc_sum_1;
  
  always @ (posedge clk)
    begin: Acc_reg_1_process
      if (reset == 1'b1) begin
        acc_out_1 <= 0;
      end
      else begin
        if (accActive == 1'b1) begin
          acc_out_1 <= acc_in_1;
        end
      end
    end // Acc_reg_1_process    
  
  always @ (posedge clk)
    begin: Finalsum_reg_process
      if (reset == 1'b1) begin
        acc_final <= 0;
      end
      else begin
        if (accActive == 1'b0) begin
          acc_final <= acc_out_1;
        end
      end
    end // Finalsum_reg_process

  assign output_typeconvert = acc_final[33:16];

  // Assignment Statements
  assign ce_out_stage3 = phase_1;
  assign filter_out_stage3 = output_typeconvert;
endmodule  // casfilt_stage3
