// -------------------------------------------------------------
//
// Module: filter
// Generated by MATLAB(R) 9.1 and the Filter Design HDL Coder 3.1.
// Generated on: 2017-03-30 10:13:40
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// OptimizeForHDL: on
// TargetDirectory: HdlFilterCIC4
// Name: casfilt
// InputDataType: numerictype(1,16,15)
// TargetLanguage: Verilog
// TestBenchName: casfilt_tb
// TestBenchUserStimulus:  User data, length 100000
// ErrorMargin: 2

// Filter Specifications:
//
// Sample Rate          : N/A (normalized frequency)
// Response             : CIC
// Specification        : Fp,Ast
// Interpolation Factor : 2
// Multirate Type       : Interpolator
// Stopband Atten.      : 30 dB
// Passband Edge        : 0.03125
// Differential Delay   : 1
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Implementation    : Fully parallel
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure      : Cascaded Integrator-Comb Interpolator
// Interpolation Factor  : 2
// Differential Delay    : 1
// Number of Sections    : 2
// Stable                : Yes
// Linear Phase          : Yes (Type 1)
//
// -------------------------------------------------------------
// Multipliers           : 84



`timescale 1 ns / 1 ns

module casfilt_stage5
               (
                clk,
                clk_enable_stage5,
                reset,
                filter_in_stage5,
                filter_out_stage5,
                ce_out_stage5
                );

  input   clk; 
  input   clk_enable_stage5; 
  input   reset; 
  input   signed [18:0] filter_in_stage5; //sfix19_En16
  output  signed [17:0] filter_out_stage5; //sfix18_En14
  output  ce_out_stage5; 

////////////////////////////////////////////////////////////////
//Module Architecture: casfilt_stage5
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [19:0] zeroconst = 20'b00000000000000000000; //sfix20_En16
  // Signals
  reg  [1:0] cur_count; // ufix2
  wire phase_0; // boolean
  //   
  reg  signed [18:0] input_register; // sfix19_En16
  //   -- Section 1 Signals 
  wire signed [18:0] section_in1; // sfix19_En16
  wire signed [19:0] section_cast1; // sfix20_En16
  reg  signed [19:0] diff1; // sfix20_En16
  wire signed [19:0] section_out1; // sfix20_En16
  wire signed [19:0] sub_cast; // sfix20_En16
  wire signed [19:0] sub_cast_1; // sfix20_En16
  wire signed [20:0] sub_temp; // sfix21_En16
  //   -- Section 2 Signals 
  wire signed [19:0] section_in2; // sfix20_En16
  reg  signed [19:0] diff2; // sfix20_En16
  wire signed [19:0] section_out2; // sfix20_En16
  wire signed [19:0] sub_cast_2; // sfix20_En16
  wire signed [19:0] sub_cast_3; // sfix20_En16
  wire signed [20:0] sub_temp_1; // sfix21_En16
  wire signed [19:0] upsampling; // sfix20_En16
  //   -- Section 3 Signals 
  wire signed [19:0] section_in3; // sfix20_En16
  wire signed [19:0] sum1; // sfix20_En16
  reg  signed [19:0] section_out3; // sfix20_En16
  wire signed [19:0] add_cast; // sfix20_En16
  wire signed [19:0] add_cast_1; // sfix20_En16
  wire signed [20:0] add_temp; // sfix21_En16
  //   -- Section 4 Signals 
  wire signed [19:0] section_in4; // sfix20_En16
  wire signed [19:0] sum2; // sfix20_En16
  reg  signed [19:0] section_out4; // sfix20_En16
  wire signed [19:0] add_cast_2; // sfix20_En16
  wire signed [19:0] add_cast_3; // sfix20_En16
  wire signed [20:0] add_temp_1; // sfix21_En16
  wire signed [17:0] output_typeconvert; // sfix18_En14

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 2'b00;
      end
      else begin
        if (clk_enable_stage5 == 1'b1) begin
          if (cur_count == 2'b01) begin
            cur_count <= 2'b00;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_0 = (cur_count == 2'b00 && clk_enable_stage5 == 1'b1)? 1 : 0;

  //   ------------------ Input Register ------------------

  always @ (posedge clk)
    begin: input_reg_process
      if (reset == 1'b1) begin
        input_register <= 0;
      end
      else begin
        if (phase_0 == 1'b1) begin
          input_register <= filter_in_stage5;
        end
      end
    end // input_reg_process

  //   ------------------ Section # 1 : Comb ------------------

  assign section_in1 = input_register;

  assign section_cast1 = $signed({{1{section_in1[18]}}, section_in1});

  assign sub_cast = section_cast1;
  assign sub_cast_1 = diff1;
  assign sub_temp = sub_cast - sub_cast_1;
  assign section_out1 = sub_temp[19:0];

  always @ (posedge clk)
    begin: comb_delay_section1
      if (reset == 1'b1) begin
        diff1 <= 0;
      end
      else begin
        if (phase_0 == 1'b1) begin
          diff1 <= section_cast1;
        end
      end
    end // comb_delay_section1

  //   ------------------ Section # 2 : Comb ------------------

  assign section_in2 = section_out1;

  assign sub_cast_2 = section_in2;
  assign sub_cast_3 = diff2;
  assign sub_temp_1 = sub_cast_2 - sub_cast_3;
  assign section_out2 = sub_temp_1[19:0];

  always @ (posedge clk)
    begin: comb_delay_section2
      if (reset == 1'b1) begin
        diff2 <= 0;
      end
      else begin
        if (phase_0 == 1'b1) begin
          diff2 <= section_in2;
        end
      end
    end // comb_delay_section2

  assign upsampling = (phase_0 == 1'b1) ? section_out2 :
                zeroconst;
  //   ------------------ Section # 3 : Integrator ------------------

  assign section_in3 = upsampling;

  assign add_cast = section_in3;
  assign add_cast_1 = section_out3;
  assign add_temp = add_cast + add_cast_1;
  assign sum1 = add_temp[19:0];

  always @ (posedge clk)
    begin: integrator_delay_section3
      if (reset == 1'b1) begin
        section_out3 <= 0;
      end
      else begin
        if (clk_enable_stage5 == 1'b1) begin
          section_out3 <= sum1;
        end
      end
    end // integrator_delay_section3

  //   ------------------ Section # 4 : Integrator ------------------

  assign section_in4 = section_out3;

  assign add_cast_2 = section_in4;
  assign add_cast_3 = section_out4;
  assign add_temp_1 = add_cast_2 + add_cast_3;
  assign sum2 = add_temp_1[19:0];

  always @ (posedge clk)
    begin: integrator_delay_section4
      if (reset == 1'b1) begin
        section_out4 <= 0;
      end
      else begin
        if (clk_enable_stage5 == 1'b1) begin
          section_out4 <= sum2;
        end
      end
    end // integrator_delay_section4

  assign output_typeconvert = section_out4[19:2];

  // Assignment Statements
  assign ce_out_stage5 = phase_0;
  assign filter_out_stage5 = output_typeconvert;
endmodule  // casfilt_stage5
