// -------------------------------------------------------------
//
// Module: filter
// Generated by MATLAB(R) 9.1 and the Filter Design HDL Coder 3.1.
// Generated on: 2017-03-30 10:13:40
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// OptimizeForHDL: on
// TargetDirectory: HdlFilterCIC4
// Name: casfilt
// InputDataType: numerictype(1,16,15)
// TargetLanguage: Verilog
// TestBenchName: casfilt_tb
// TestBenchUserStimulus:  User data, length 100000
// ErrorMargin: 2

// Filter Specifications:
//
// Sample Rate          : N/A (normalized frequency)
// Response             : CIC
// Specification        : Fp,Ast
// Interpolation Factor : 2
// Multirate Type       : Interpolator
// Stopband Atten.      : 22 dB
// Passband Edge        : 0.0078125
// Differential Delay   : 1
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Implementation    : Fully parallel
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure      : Cascaded Integrator-Comb Interpolator
// Interpolation Factor  : 2
// Differential Delay    : 1
// Number of Sections    : 1
// Stable                : Yes
// Linear Phase          : Yes (Type 2)
//
// -------------------------------------------------------------
// Multipliers           : 84



`timescale 1 ns / 1 ns

module casfilt_stage7
               (
                clk,
                clk_enable_stage7,
                reset,
                filter_in_stage7,
                filter_out_stage7,
                ce_out_stage7
                );

  input   clk; 
  input   clk_enable_stage7; 
  input   reset; 
  input   signed [16:0] filter_in_stage7; //sfix17_En13
  output  signed [15:0] filter_out_stage7; //sfix16_En12
  output  ce_out_stage7; 

////////////////////////////////////////////////////////////////
//Module Architecture: casfilt_stage7
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [16:0] zeroconst = 17'b00000000000000000; //sfix17_En13
  // Signals
  reg  [1:0] cur_count; // ufix2
  wire phase_0; // boolean
  //   
  reg  signed [16:0] input_register; // sfix17_En13
  //   -- Section 1 Signals 
  wire signed [16:0] section_in1; // sfix17_En13
  reg  signed [16:0] diff1; // sfix17_En13
  wire signed [16:0] section_out1; // sfix17_En13
  wire signed [16:0] sub_cast; // sfix17_En13
  wire signed [16:0] sub_cast_1; // sfix17_En13
  wire signed [17:0] sub_temp; // sfix18_En13
  wire signed [16:0] upsampling; // sfix17_En13
  //   -- Section 2 Signals 
  wire signed [16:0] section_in2; // sfix17_En13
  wire signed [16:0] sum1; // sfix17_En13
  reg  signed [16:0] section_out2; // sfix17_En13
  wire signed [16:0] add_cast; // sfix17_En13
  wire signed [16:0] add_cast_1; // sfix17_En13
  wire signed [17:0] add_temp; // sfix18_En13
  wire signed [15:0] output_typeconvert; // sfix16_En12
  //   
  reg  signed [15:0] output_register; // sfix16_En12

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 2'b00;
      end
      else begin
        if (clk_enable_stage7 == 1'b1) begin
          if (cur_count == 2'b01) begin
            cur_count <= 2'b00;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_0 = (cur_count == 2'b00 && clk_enable_stage7 == 1'b1)? 1 : 0;

  //   ------------------ Input Register ------------------

  always @ (posedge clk)
    begin: input_reg_process
      if (reset == 1'b1) begin
        input_register <= 0;
      end
      else begin
        if (phase_0 == 1'b1) begin
          input_register <= filter_in_stage7;
        end
      end
    end // input_reg_process

  //   ------------------ Section # 1 : Comb ------------------

  assign section_in1 = input_register;

  assign sub_cast = section_in1;
  assign sub_cast_1 = diff1;
  assign sub_temp = sub_cast - sub_cast_1;
  assign section_out1 = sub_temp[16:0];

  always @ (posedge clk)
    begin: comb_delay_section1
      if (reset == 1'b1) begin
        diff1 <= 0;
      end
      else begin
        if (phase_0 == 1'b1) begin
          diff1 <= section_in1;
        end
      end
    end // comb_delay_section1

  assign upsampling = (phase_0 == 1'b1) ? section_out1 :
                zeroconst;
  //   ------------------ Section # 2 : Integrator ------------------

  assign section_in2 = upsampling;

  assign add_cast = section_in2;
  assign add_cast_1 = section_out2;
  assign add_temp = add_cast + add_cast_1;
  assign sum1 = add_temp[16:0];

  always @ (posedge clk)
    begin: integrator_delay_section2
      if (reset == 1'b1) begin
        section_out2 <= 0;
      end
      else begin
        if (clk_enable_stage7 == 1'b1) begin
          section_out2 <= sum1;
        end
      end
    end // integrator_delay_section2

  assign output_typeconvert = section_out2[16:1];

  //   ------------------ Output Register ------------------

  always @ (posedge clk)
    begin: output_reg_process
      if (reset == 1'b1) begin
        output_register <= 0;
      end
      else begin
        if (clk_enable_stage7 == 1'b1) begin
          output_register <= output_typeconvert;
        end
      end
    end // output_reg_process

  // Assignment Statements
  assign ce_out_stage7 = phase_0;
  assign filter_out_stage7 = output_register;
endmodule  // casfilt_stage7
