//********************************************************************************
//                                                                                
//       Nordic Semiconductor ASA, Otto Nielsens vei 12, N-7004 TRONDHEIM, NORWAY
//                                                                                
//********************************************************************************
// Project name   :                                                        
// Project number :                                                        
// File type      : Verilog rtl.                                                  
// Designer       : Håkon Tobias Jøsok
// Description    : Sigma-Delta DAC for audio application with 16 bits in, and 1 bit out
//
//               
//********************************************************************************


module dac(
            input   logic               ck,  
            input   logic               rst, 
            input   logic               sdInternalRst,
            input   logic               ck_enable,
            input   logic signed [15:0] dataIn,
            output  logic               ce_out,
            output  logic               dataOut
           );
  
 
  logic signed [15:0] filterOut; 
  
  sdMod u_sdMod(.ck(ck),
                .rst(rst),
                .instabilityRst(sdInternalRst),
                .ck_enable(ck_enable),
                .u(filterOut), 
                .v(dataOut)
                );
  
  casfilt u_casfilt(.clk(ck),
                    .clk_enable(ck_enable),
                    .reset(rst),
                    .filter_in(dataIn),
                    .filter_out(filterOut),
                    .ce_out(ce_out)
                    );
  
endmodule