proc start_step { step } {
  set stopFile ".stop.rst"
  if {[file isfile .stop.rst]} {
    puts ""
    puts "*** Halting run - EA reset detected ***"
    puts ""
    puts ""
    return -code error
  }
  set beginFile ".$step.begin.rst"
  set platform "$::tcl_platform(platform)"
  set user "$::tcl_platform(user)"
  set pid [pid]
  set host ""
  if { [string equal $platform unix] } {
    if { [info exist ::env(HOSTNAME)] } {
      set host $::env(HOSTNAME)
    }
  } else {
    if { [info exist ::env(COMPUTERNAME)] } {
      set host $::env(COMPUTERNAME)
    }
  }
  set ch [open $beginFile w]
  puts $ch "<?xml version=\"1.0\"?>"
  puts $ch "<ProcessHandle Version=\"1\" Minor=\"0\">"
  puts $ch "    <Process Command=\".planAhead.\" Owner=\"$user\" Host=\"$host\" Pid=\"$pid\">"
  puts $ch "    </Process>"
  puts $ch "</ProcessHandle>"
  close $ch
}

proc end_step { step } {
  set endFile ".$step.end.rst"
  set ch [open $endFile w]
  close $ch
}

proc step_failed { step } {
  set endFile ".$step.error.rst"
  set ch [open $endFile w]
  close $ch
}

set_msg_config -id {HDL 9-1061} -limit 100000
set_msg_config -id {HDL 9-1654} -limit 100000

start_step init_design
set ACTIVE_STEP init_design
set rc [catch {
  create_msg_db init_design.pb
  create_project -in_memory -part xc7z020clg484-1
  set_property board_part em.avnet.com:zed:part0:0.9 [current_project]
  set_property design_mode GateLvl [current_fileset]
  set_param project.singleFileAddWarning.threshold 0
  set_property webtalk.parent_dir /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.cache/wt [current_project]
  set_property parent.project_path /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.xpr [current_project]
  set_property ip_repo_paths {
  /home/tobias/Dropbox/Workspace/Masteroppgave/ip_repo/SD_DAC_2.0
  /home/tobias/Dropbox/Workspace/Masteroppgave/ip_repo/SD_DAC_1.0
  /home/tobias/Dropbox/Workspace/Masteroppgave/ip_repo/SD_DAC_1.0
} [current_project]
  set_property ip_output_repo /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.cache/ip [current_project]
  set_property ip_cache_permissions {read write} [current_project]
  set_property XPM_LIBRARIES {XPM_CDC XPM_MEMORY} [current_project]
  add_files -quiet /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.runs/synth_1/DacFpga_wrapper.dcp
  read_xdc -ref DacFpga_axis_data_fifo_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0.xdc]
  read_xdc -ref DacFpga_processing_system7_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_processing_system7_0_0/DacFpga_processing_system7_0_0.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_processing_system7_0_0/DacFpga_processing_system7_0_0.xdc]
  read_xdc -ref DacFpga_SD_DAC_0_4 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_SD_DAC_0_4/src/SD_DAC_CONS.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_SD_DAC_0_4/src/SD_DAC_CONS.xdc]
  read_xdc -ref DacFpga_ila_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_ila_0_0/ila_v6_2/constraints/ila.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_ila_0_0/ila_v6_2/constraints/ila.xdc]
  read_xdc -ref DacFpga_jtag_axi_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_jtag_axi_0_0/constraints/jtag_axi.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_jtag_axi_0_0/constraints/jtag_axi.xdc]
  read_xdc -prop_thru_buffers -ref DacFpga_rst_ps7_0_100M_0 -cells U0 /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_rst_ps7_0_100M_0/DacFpga_rst_ps7_0_100M_0_board.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_rst_ps7_0_100M_0/DacFpga_rst_ps7_0_100M_0_board.xdc]
  read_xdc -ref DacFpga_rst_ps7_0_100M_0 -cells U0 /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_rst_ps7_0_100M_0/DacFpga_rst_ps7_0_100M_0.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_rst_ps7_0_100M_0/DacFpga_rst_ps7_0_100M_0.xdc]
  read_xdc -ref DacFpga_axi_dma_0_0 -cells U0 /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axi_dma_0_0/DacFpga_axi_dma_0_0.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axi_dma_0_0/DacFpga_axi_dma_0_0.xdc]
  read_xdc -prop_thru_buffers -ref DacFpga_proc_sys_reset_0_0 -cells U0 /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_proc_sys_reset_0_0/DacFpga_proc_sys_reset_0_0_board.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_proc_sys_reset_0_0/DacFpga_proc_sys_reset_0_0_board.xdc]
  read_xdc -ref DacFpga_proc_sys_reset_0_0 -cells U0 /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_proc_sys_reset_0_0/DacFpga_proc_sys_reset_0_0.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_proc_sys_reset_0_0/DacFpga_proc_sys_reset_0_0.xdc]
  read_xdc -prop_thru_buffers -ref DacFpga_clk_wiz_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_clk_wiz_0_0_1/DacFpga_clk_wiz_0_0_board.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_clk_wiz_0_0_1/DacFpga_clk_wiz_0_0_board.xdc]
  read_xdc -ref DacFpga_clk_wiz_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_clk_wiz_0_0_1/DacFpga_clk_wiz_0_0.xdc
  set_property processing_order EARLY [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_clk_wiz_0_0_1/DacFpga_clk_wiz_0_0.xdc]
  read_xdc /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/constrs_1/new/DAC_PL_clock.xdc
  read_xdc -ref DacFpga_axis_data_fifo_0_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0_clocks.xdc
  set_property processing_order LATE [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0/DacFpga_axis_data_fifo_0_0_clocks.xdc]
  read_xdc -ref DacFpga_axi_dma_0_0 -cells U0 /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axi_dma_0_0/DacFpga_axi_dma_0_0_clocks.xdc
  set_property processing_order LATE [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_axi_dma_0_0/DacFpga_axi_dma_0_0_clocks.xdc]
  read_xdc -ref DacFpga_auto_cc_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_auto_cc_0/DacFpga_auto_cc_0_clocks.xdc
  set_property processing_order LATE [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_auto_cc_0/DacFpga_auto_cc_0_clocks.xdc]
  read_xdc -ref DacFpga_auto_cc_1 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_auto_cc_1/DacFpga_auto_cc_1_clocks.xdc
  set_property processing_order LATE [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_auto_cc_1/DacFpga_auto_cc_1_clocks.xdc]
  read_xdc -ref DacFpga_auto_us_0 -cells inst /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_auto_us_0/DacFpga_auto_us_0_clocks.xdc
  set_property processing_order LATE [get_files /home/tobias/Dropbox/Workspace/Masteroppgave/DAC-FPGA/DAC-FPGA.srcs/sources_1/bd/DacFpga/ip/DacFpga_auto_us_0/DacFpga_auto_us_0_clocks.xdc]
  link_design -top DacFpga_wrapper -part xc7z020clg484-1
  write_hwdef -file DacFpga_wrapper.hwdef
  close_msg_db -file init_design.pb
} RESULT]
if {$rc} {
  step_failed init_design
  return -code error $RESULT
} else {
  end_step init_design
  unset ACTIVE_STEP 
}

start_step opt_design
set ACTIVE_STEP opt_design
set rc [catch {
  create_msg_db opt_design.pb
  opt_design 
  write_checkpoint -force DacFpga_wrapper_opt.dcp
  catch { report_drc -file DacFpga_wrapper_drc_opted.rpt }
  close_msg_db -file opt_design.pb
} RESULT]
if {$rc} {
  step_failed opt_design
  return -code error $RESULT
} else {
  end_step opt_design
  unset ACTIVE_STEP 
}

start_step place_design
set ACTIVE_STEP place_design
set rc [catch {
  create_msg_db place_design.pb
  implement_debug_core 
  place_design 
  write_checkpoint -force DacFpga_wrapper_placed.dcp
  catch { report_io -file DacFpga_wrapper_io_placed.rpt }
  catch { report_utilization -file DacFpga_wrapper_utilization_placed.rpt -pb DacFpga_wrapper_utilization_placed.pb }
  catch { report_control_sets -verbose -file DacFpga_wrapper_control_sets_placed.rpt }
  close_msg_db -file place_design.pb
} RESULT]
if {$rc} {
  step_failed place_design
  return -code error $RESULT
} else {
  end_step place_design
  unset ACTIVE_STEP 
}

start_step route_design
set ACTIVE_STEP route_design
set rc [catch {
  create_msg_db route_design.pb
  route_design 
  write_checkpoint -force DacFpga_wrapper_routed.dcp
  catch { report_drc -file DacFpga_wrapper_drc_routed.rpt -pb DacFpga_wrapper_drc_routed.pb -rpx DacFpga_wrapper_drc_routed.rpx }
  catch { report_methodology -file DacFpga_wrapper_methodology_drc_routed.rpt -rpx DacFpga_wrapper_methodology_drc_routed.rpx }
  catch { report_timing_summary -warn_on_violation -max_paths 10 -file DacFpga_wrapper_timing_summary_routed.rpt -rpx DacFpga_wrapper_timing_summary_routed.rpx }
  catch { report_power -file DacFpga_wrapper_power_routed.rpt -pb DacFpga_wrapper_power_summary_routed.pb -rpx DacFpga_wrapper_power_routed.rpx }
  catch { report_route_status -file DacFpga_wrapper_route_status.rpt -pb DacFpga_wrapper_route_status.pb }
  catch { report_clock_utilization -file DacFpga_wrapper_clock_utilization_routed.rpt }
  close_msg_db -file route_design.pb
} RESULT]
if {$rc} {
  write_checkpoint -force DacFpga_wrapper_routed_error.dcp
  step_failed route_design
  return -code error $RESULT
} else {
  end_step route_design
  unset ACTIVE_STEP 
}

start_step write_bitstream
set ACTIVE_STEP write_bitstream
set rc [catch {
  create_msg_db write_bitstream.pb
  set_property XPM_LIBRARIES {XPM_CDC XPM_MEMORY} [current_project]
  catch { write_mem_info -force DacFpga_wrapper.mmi }
  write_bitstream -force -no_partial_bitfile DacFpga_wrapper.bit 
  catch { write_sysdef -hwdef DacFpga_wrapper.hwdef -bitfile DacFpga_wrapper.bit -meminfo DacFpga_wrapper.mmi -file DacFpga_wrapper.sysdef }
  catch {write_debug_probes -quiet -force debug_nets}
  close_msg_db -file write_bitstream.pb
} RESULT]
if {$rc} {
  step_failed write_bitstream
  return -code error $RESULT
} else {
  end_step write_bitstream
  unset ACTIVE_STEP 
}

